Program matrix_noopengl;

{$MODE objfpc}{$H+}

Uses
{$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
{$ENDIF}{$ENDIF}
  Classes,
  sysutils,
  x,
  xlib,
  ctypes
  { you can add units after this };

{$R *.res}

Var
  xdisplay: PDisplay;
  screen: cint;
  window: TWindow = 0;
  root: TWindow;
  windowW: integer = 1280;
  windowH: integer = 800;
  event: PXEvent;
  Runs: Boolean;
  drawroot: Boolean = false;
  attribs: TXWindowAttributes;
  visual: PVisual;

  // Liest die Übergabeparameter aus

Procedure Parse;
Var
  i: Integer;
  s: String;
Begin
  writeln('Parse Params :');
  i := 1;
  While i <= Paramcount Do Begin
    s := lowercase(paramstr(i));
    If s = '-root' Then Begin
      drawroot := True;
    End
    Else If s = '-window-id' Then Begin
      inc(i);
      s := lowercase(paramstr(i));
      window := strtoint(s);
    End
    Else Begin
      writeln('Error unknown option : ' + s);
    End;
    inc(i);
  End;
End;

Begin
  parse;
  xdisplay := XOpenDisplay(Nil);
  If Not assigned(xdisplay) Then Begin
    writeln('Error could not init XOpenDisplay');
    exit;
  End;
  screen := DefaultScreen(xdisplay);

  If (Window = 0) Then Begin
    root := RootWindow(xdisplay, screen);
    If (drawroot) Then Begin
      window := root;
    End
    Else Begin
      window := XCreateSimpleWindow(xdisplay, root, 0, 0, windowW, windowH, 0, 0, 255);
    End;
  End;

  XGetWindowAttributes(xdisplay, window, @attribs);

  (* tell the display server what kind of events we would like to see *)
//  XSelectInput(xdisplay, window, ButtonPressMask Or StructureNotifyMask);

  Visual := attribs.visual;



  XMapRaised(xdisplay, window);
  new(event);
  runs := true;
  // Endlosschleife der Anwendung macht man dass, gibts 100 % CPU-Load
  //  While runs Do Begin

    // Auslesen aller Events die gerade so anstehen
  While {(XPending(xdisplay) <> 0) And }runs Do Begin
    XNextEvent(xdisplay, event);
    Case event^._type Of
      ConfigureNotify: Begin
          If (windowW <> event^.xconfigure.width)
            Or (windowH <> event^.xconfigure.height) Then Begin
            windowW := event^.xconfigure.width;
            windowH := event^.xconfigure.height;
          End;
        End;
      ButtonPress: Begin
          runs := false;
        End;
    End;
    //      sleep(40);
    //    End;
  End;
  XDestroyWindow(xdisplay, window);
  XCloseDisplay(xdisplay);
  dispose(event);
End.

